#include <vga.h>
extern int swScanWidth;

int bpp8_getbitmap(int x,int y,int w,int h,char *bmp)
{
  unsigned char * gp = vga_getgraphmem();
  unsigned char * p  = gp;
  int nx,ny,dw;
  int addr = y * swScanWidth + x;
  int next;
  int page = addr>>16;
  
  vga_setpage(page);
  
  addr &= 0xffff;
  next = addr + w;
  p+=addr;

  for (ny=0;ny<h;ny++,addr+=swScanWidth,next+=swScanWidth) {
    if (addr>0xffff) {
      page++;
      vga_setpage(page);
      addr &= 0xffff;
      next = addr + w;
      p = gp;
      p+= addr;
    }
    if (next>0x10000) {
      dw = 0x10000 - addr;
      memcpy(bmp,p,dw);
      bmp+=dw;
      vga_setpage(page+1);
      p = gp;
      dw = w - dw;
      memcpy(bmp,p,dw);
      bmp += dw;
    } else {
      memcpy(bmp,p,w);
      p += swScanWidth; bmp += w;
    }
  }
  
  return 1;
}
